#include <iostream>
#include <vector>
using namespace std;

vector<int> graf;
vector<int> links;
vector<int> ans;

int rec(int v, vector<int> & ng, int deep) {
    graf[v] = 1;
    ng.push_back(v);
    if (graf[links[v]] == 0) {
        return rec(links[v], ng, deep + 1);
    }
    if (graf[links[v]] == 1) {
        ans = ng;
        return deep;
    }
}

int main() {
    int n;
    cin >> n;
    links.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> links[i];
        links[i]--;
    }
    graf.resize(n, 0);
    int count = 0;
    int x;
    vector<int> first;
    vector<int> second;
    for (int i = 0; i < n; i++) {
        if (graf[i] == 0) {
            vector<int> ng;
            x = rec(i, ng, 1);
            if (x % 2 == 1) {
                count++;
                ans.pop_back();
            }
            for (int k = 0; k < ans.size(); k++) {
                if (k % 2 == 0) {
                    first.push_back(ans[k]);
                } else {
                    second.push_back(ans[k]);
                }
            }
        }
    }
    cout << count << endl;
    for (int i = 0; i < first.size(); i++) {
        cout << first[i] + 1 << " ";
    }
    cout << endl;
    for (int i = 0; i < second.size(); i++) {
        cout << second[i] + 1 << " ";
    }
    return 0;
}